Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxwindow.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxwindow.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxwindow.c
@@ -46,11 +46,25 @@
 #include "dmxvisual.h"
 #include "dmxinput.h"
 #include "dmxextension.h"
+#include "dmxscrinit.h"
+#include "dmxcursor.h"
+#include "dmxfont.h"
+#include "dmxatom.h"
+#include "dmxprop.h"
+#include "dmxselection.h"
+#include "dmxdnd.h"
 #ifdef RENDER
 #include "dmxpict.h"
 #endif
 
 #include "windowstr.h"
+#include "propertyst.h"
+#include "dixfont.h"
+
+#ifdef PANORAMIX
+#include "panoramiX.h"
+#include "panoramiXsrv.h"
+#endif
 
 static void dmxDoRestackWindow(WindowPtr pWindow);
 static void dmxDoChangeWindowAttributes(WindowPtr pWindow,
@@ -59,6 +73,12 @@ static void dmxDoChangeWindowAttributes(
 
 static void dmxDoSetShape(WindowPtr pWindow);
 
+static void
+dmxDoRedirectWindow(WindowPtr pWindow);
+
+static void
+dmxDoUpdateWindowPixmap(WindowPtr pWindow);
+
 /** Initialize the private area for the window functions. */
 Bool dmxInitWindow(ScreenPtr pScreen)
 {
@@ -76,66 +96,82 @@ Window dmxCreateRootWindow(WindowPtr pWi
     dmxWinPrivPtr         pWinPriv  = DMX_GET_WINDOW_PRIV(pWindow);
     Window                parent;
     Visual               *visual;
-    unsigned long         mask;
+    unsigned long         mask = 0;
     XSetWindowAttributes  attribs;
     ColormapPtr           pCmap;
     dmxColormapPrivPtr    pCmapPriv;
+    Window                win = None;
+    int                   w = pWindow->drawable.width;
+    int                   h = pWindow->drawable.height;
+
+    /* Avoid to create windows on back-end servers with virtual framebuffer */
+    if (dmxScreen->virtualFb)
+	return None;
 
-    /* Create root window */
+    mask = CWEventMask;
+    attribs.event_mask = dmxScreen->rootEventMask;
+
+    /* Incorporate new attributes, if needed */
+    if (pWinPriv->attribMask) {
+	dmxDoChangeWindowAttributes(pWindow, &pWinPriv->attribMask, &attribs);
+	mask |= pWinPriv->attribMask;
+    }
 
+    /* Create root window */
     parent = dmxScreen->scrnWin; /* This is our "Screen" window */
     visual = dmxScreen->beVisuals[dmxScreen->beDefVisualIndex].visual;
 
     pCmap = (ColormapPtr)LookupIDByType(wColormap(pWindow), RT_COLORMAP);
     pCmapPriv = DMX_GET_COLORMAP_PRIV(pCmap);
 
-    mask = CWEventMask | CWBackingStore | CWColormap | CWBorderPixel;
-    attribs.event_mask    = ExposureMask;
-    attribs.backing_store = NotUseful;
-    attribs.colormap      = pCmapPriv->cmap;
-    attribs.border_pixel  = 0;
-
-    /* Incorporate new attributes, if needed */
-    if (pWinPriv->attribMask) {
-	dmxDoChangeWindowAttributes(pWindow, &pWinPriv->attribMask, &attribs);
-	mask |= pWinPriv->attribMask;
+    mask |= CWBackingStore | CWColormap | CWBorderPixel | CWOverrideRedirect;
+    attribs.backing_store     = NotUseful;
+    attribs.colormap          = pCmapPriv->cmap;
+    attribs.border_pixel      = 0;
+    attribs.override_redirect = TRUE;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
     }
+#endif
 
-    return XCreateWindow(dmxScreen->beDisplay,
-			 parent,
-			 pWindow->origin.x - wBorderWidth(pWindow),
-			 pWindow->origin.y - wBorderWidth(pWindow),
-			 pWindow->drawable.width,
-			 pWindow->drawable.height,
-			 pWindow->borderWidth,
-			 pWindow->drawable.depth,
-			 pWindow->drawable.class,
-			 visual,
-			 mask,
-			 &attribs);
-}
-
-/** Change the location and size of the "screen" window.  Called from
- *  #dmxReconfigureScreenWindow(). */
-void dmxResizeScreenWindow(ScreenPtr pScreen,
-			   int x, int y, int w, int h)
-{
-    DMXScreenInfo  *dmxScreen = &dmxScreens[pScreen->myNum];
-    unsigned int    m;
-    XWindowChanges  c;
+    XLIB_PROLOGUE (dmxScreen);
+    win = XCreateWindow(dmxScreen->beDisplay,
+			parent,
+			dmxScreen->rootX +
+			pWindow->origin.x - wBorderWidth(pWindow),
+			dmxScreen->rootY +
+			pWindow->origin.y - wBorderWidth(pWindow),
+			w,
+			h,
+			pWindow->borderWidth,
+			pWindow->drawable.depth,
+			pWindow->drawable.class,
+			visual,
+			mask,
+			&attribs);
+    XLIB_EPILOGUE (dmxScreen);
+
+    xcb_change_property (dmxScreen->connection,
+			 XCB_PROP_MODE_REPLACE,
+			 win,
+			 XInternAtom (dmxScreen->beDisplay, "DMX_NAME", False),
+			 XA_STRING,
+			 8,
+			 strlen (dmxDigest),
+			 (unsigned char *) dmxDigest);
 
-    if (!dmxScreen->beDisplay)
-	return;
+    dmxBEDnDRootWindowUpdate (pWindow->drawable.pScreen, win);
 
-    /* Handle resizing on back-end server */
-    m = CWX | CWY | CWWidth | CWHeight;
-    c.x = x;
-    c.y = y;
-    c.width = w;
-    c.height = h;
+    return win;
+}
 
-    XConfigureWindow(dmxScreen->beDisplay, dmxScreen->scrnWin, m, &c);
-    dmxSync(dmxScreen, False);
+static void dmxSetIgnore (DMXScreenInfo *dmxScreen, unsigned int sequence)
+{
+    dmxAddSequence (&dmxScreen->ignore, sequence);
 }
 
 /** Change the location and size of the "root" window.  Called from
@@ -148,6 +184,9 @@ void dmxResizeRootWindow(WindowPtr pRoot
     unsigned int    m;
     XWindowChanges  c;
 
+    if (!pWinPriv->window)
+	return;
+
     /* Handle resizing on back-end server */
     if (dmxScreen->beDisplay) {
 	m = CWX | CWY | CWWidth | CWHeight;
@@ -156,18 +195,31 @@ void dmxResizeRootWindow(WindowPtr pRoot
 	c.width = (w > 0) ? w : 1;
 	c.height = (h > 0) ? h : 1;
 
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+	XLIB_EPILOGUE (dmxScreen);
     }
 
     if (w == 0 || h == 0) {
 	if (pWinPriv->mapped) {
 	    if (dmxScreen->beDisplay)
+	    {
+		XLIB_PROLOGUE (dmxScreen);
+		dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 		XUnmapWindow(dmxScreen->beDisplay, pWinPriv->window);
+		XLIB_EPILOGUE (dmxScreen);
+	    }
 	    pWinPriv->mapped = FALSE;
 	}
     } else if (!pWinPriv->mapped) {
 	if (dmxScreen->beDisplay)
+	{
+	    XLIB_PROLOGUE (dmxScreen);
+	    dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	    XMapWindow(dmxScreen->beDisplay, pWinPriv->window);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
 	pWinPriv->mapped = TRUE;
     }
 
@@ -215,6 +267,12 @@ static Window dmxCreateNonRootWindow(Win
     unsigned long         mask = 0L;
     XSetWindowAttributes  attribs;
     dmxWinPrivPtr         pParentPriv = DMX_GET_WINDOW_PRIV(pWindow->parent);
+    Window                win = None;
+    int                   x, y, w, h, bw;
+
+    /* Avoid to create windows on back-end servers with virtual framebuffer */
+    if (dmxScreen->virtualFb)
+	return None;
 
     /* Create window on back-end server */
 
@@ -228,6 +286,9 @@ static Window dmxCreateNonRootWindow(Win
 	parent = pParentPriv->window;
     }
 
+    mask |= CWEventMask;
+    attribs.event_mask = ExposureMask | SubstructureRedirectMask;
+
     /* Incorporate new attributes, if needed */
     if (pWinPriv->attribMask) {
 	dmxDoChangeWindowAttributes(pWindow, &pWinPriv->attribMask, &attribs);
@@ -254,18 +315,37 @@ static Window dmxCreateNonRootWindow(Win
        be created on top of the stack, so we must restack the windows */
     pWinPriv->restacked = (pWindow->prevSib != NullWindow);
 
-    return XCreateWindow(dmxScreen->beDisplay,
-			 parent,
-			 pWindow->origin.x - wBorderWidth(pWindow),
-			 pWindow->origin.y - wBorderWidth(pWindow),
-			 pWindow->drawable.width,
-			 pWindow->drawable.height,
-			 pWindow->borderWidth,
-			 pWindow->drawable.depth,
-			 pWindow->drawable.class,
-			 pWinPriv->visual,
-			 mask,
-			 &attribs);
+    if (pWindow != dmxScreen->pInputOverlayWin)
+    {
+	x = pWindow->origin.x - wBorderWidth(pWindow);
+	y = pWindow->origin.y - wBorderWidth(pWindow);
+	w = pWindow->drawable.width;
+	h = pWindow->drawable.height;
+	bw = pWindow->borderWidth;
+    }
+    else
+    {
+	x = y = -1;
+	w = h = 1;
+	bw = 0;
+    }
+
+    XLIB_PROLOGUE (dmxScreen);
+    win = XCreateWindow(dmxScreen->beDisplay,
+			parent,
+			x,
+			y,
+			w,
+			h,
+			bw,
+			pWindow->drawable.depth,
+			pWindow->drawable.class,
+			pWinPriv->visual,
+			mask,
+			&attribs);
+    XLIB_EPILOGUE (dmxScreen);
+
+    return win;
 }
 
 /** This function handles lazy window creation and realization.  Window
@@ -285,15 +365,29 @@ void dmxCreateAndRealizeWindow(WindowPtr
 
     if (!dmxScreen->beDisplay) return;
 
-    pWinPriv->window = dmxCreateNonRootWindow(pWindow);
-    if (pWinPriv->restacked) dmxDoRestackWindow(pWindow);
-    if (pWinPriv->isShaped) dmxDoSetShape(pWindow);
+    if (!pWindow->parent)
+	dmxScreen->rootWin = pWinPriv->window = dmxCreateRootWindow(pWindow);
+    else
+	pWinPriv->window = dmxCreateNonRootWindow(pWindow);
+    if (pWinPriv->window)
+    {
+	if (pWinPriv->redirected) dmxDoRedirectWindow(pWindow);
+	if (pWinPriv->restacked) dmxDoRestackWindow(pWindow);
+	if (pWinPriv->isShaped) dmxDoSetShape(pWindow);
 #ifdef RENDER
-    if (pWinPriv->hasPict) dmxCreatePictureList(pWindow);
+	if (pWinPriv->hasPict) dmxCreatePictureList(pWindow);
 #endif
-    if (pWinPriv->mapped) XMapWindow(dmxScreen->beDisplay,
-				      pWinPriv->window);
-    if (doSync) dmxSync(dmxScreen, False);
+	if (pWinPriv->mapped)
+	{
+	    XLIB_PROLOGUE (dmxScreen);
+	    dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
+	    XMapWindow(dmxScreen->beDisplay, pWinPriv->window);
+	    XLIB_EPILOGUE (dmxScreen);
+
+	    if (pWinPriv->beRedirected) dmxDoUpdateWindowPixmap (pWindow);
+	}
+	if (doSync) dmxSync(dmxScreen, False);
+    }
 }
 
 /** Create \a pWindow on the back-end server.  If the lazy window
@@ -308,16 +402,16 @@ Bool dmxCreateWindow(WindowPtr pWindow)
     Bool                  ret = TRUE;
 
     DMX_UNWRAP(CreateWindow, dmxScreen, pScreen);
-#if 0
+
     if (pScreen->CreateWindow)
 	ret = pScreen->CreateWindow(pWindow);
-#endif
 
     /* Set up the defaults */
     pWinPriv->window     = (Window)0;
     pWinPriv->offscreen  = TRUE;
     pWinPriv->mapped     = FALSE;
     pWinPriv->restacked  = FALSE;
+    pWinPriv->redirected = FALSE;
     pWinPriv->attribMask = 0;
     pWinPriv->isShaped   = FALSE;
 #ifdef RENDER
@@ -328,29 +422,14 @@ Bool dmxCreateWindow(WindowPtr pWindow)
     pWinPriv->barrier    = 0;
 #endif
 
+    pWinPriv->beRedirected = FALSE;
+
     if (dmxScreen->beDisplay) {
 	/* Only create the root window at this stage -- non-root windows are
 	   created when they are mapped and are on-screen */
 	if (!pWindow->parent) {
-	    dmxScreen->rootWin = pWinPriv->window
-		= dmxCreateRootWindow(pWindow);
-	    if (dmxScreen->scrnX         != dmxScreen->rootX
-		|| dmxScreen->scrnY      != dmxScreen->rootY
-		|| dmxScreen->scrnWidth  != dmxScreen->rootWidth
-		|| dmxScreen->scrnHeight != dmxScreen->rootHeight) {
-		dmxResizeRootWindow(pWindow,
-				    dmxScreen->rootX,
-				    dmxScreen->rootY,
-				    dmxScreen->rootWidth,
-				    dmxScreen->rootHeight);
-		dmxUpdateScreenResources(screenInfo.screens[dmxScreen->index],
-					 dmxScreen->rootX,
-					 dmxScreen->rootY,
-					 dmxScreen->rootWidth,
-					 dmxScreen->rootHeight);
-		pWindow->origin.x = dmxScreen->rootX;
-		pWindow->origin.y = dmxScreen->rootY;
-	    }
+	    dmxScreen->rootWin = pWinPriv->window =
+		dmxCreateRootWindow(pWindow);
 	} else {
 	    dmxGetDefaultWindowAttributes(pWindow,
 					  &pWinPriv->cmap,
@@ -382,8 +461,15 @@ Bool dmxBEDestroyWindow(WindowPtr pWindo
     DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
     dmxWinPrivPtr  pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
 
+    pWinPriv->beRedirected = FALSE;
+
     if (pWinPriv->window) {
-	XDestroyWindow(dmxScreen->beDisplay, pWinPriv->window);
+	if (dmxScreen->scrnWin)
+	{
+	    XLIB_PROLOGUE (dmxScreen);
+	    XDestroyWindow(dmxScreen->beDisplay, pWinPriv->window);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
 	pWinPriv->window = (Window)0;
 	return TRUE;
     }
@@ -419,10 +505,9 @@ Bool dmxDestroyWindow(WindowPtr pWindow)
 	pWinPriv->windowDestroyed(pWindow);
 #endif
 
-#if 0
     if (pScreen->DestroyWindow)
 	ret = pScreen->DestroyWindow(pWindow);
-#endif
+
     DMX_WRAP(DestroyWindow, dmxDestroyWindow, dmxScreen, pScreen);
 
     return ret;
@@ -439,10 +524,8 @@ Bool dmxPositionWindow(WindowPtr pWindow
     XWindowChanges  c;
 
     DMX_UNWRAP(PositionWindow, dmxScreen, pScreen);
-#if 0
     if (pScreen->PositionWindow)
 	ret = pScreen->PositionWindow(pWindow, x, y);
-#endif
 
     /* Determine if the window is completely off the visible portion of
        the screen */
@@ -452,7 +535,7 @@ Bool dmxPositionWindow(WindowPtr pWindow
        been created yet, create it and map it */
     if (!pWinPriv->window && pWinPriv->mapped && !pWinPriv->offscreen) {
 	dmxCreateAndRealizeWindow(pWindow, TRUE);
-    } else if (pWinPriv->window) {
+    } else if (pWinPriv->window && pWindow != dmxScreen->pInputOverlayWin) {
 	/* Position window on back-end server */
 	m = CWX | CWY | CWWidth | CWHeight;
 	c.x = pWindow->origin.x - wBorderWidth(pWindow);
@@ -464,7 +547,10 @@ Bool dmxPositionWindow(WindowPtr pWindow
 	    c.border_width = pWindow->borderWidth;
 	}
 
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, False);
     }
 
@@ -539,7 +625,12 @@ static void dmxDoChangeWindowAttributes(
 	*mask &= ~CWBackingPixel; /* Backing store not supported */
 
     if (*mask & CWOverrideRedirect)
-	attribs->override_redirect = pWindow->overrideRedirect;
+    {
+	if (pWindow->parent)
+	    attribs->override_redirect = pWindow->overrideRedirect;
+	else
+	    *mask &= ~CWOverrideRedirect;
+    }
 
     if (*mask & CWSaveUnder)
 	*mask &= ~CWSaveUnder; /* Save unders not supported */
@@ -560,7 +651,21 @@ static void dmxDoChangeWindowAttributes(
     }
 
     if (*mask & CWCursor)
-	*mask &= ~CWCursor; /* Handled by the cursor code */
+    {
+	ScreenPtr pScreen = pWindow->drawable.pScreen;
+
+	if (pWindow->cursorIsNone)
+	{
+	    attribs->cursor = None;
+	}
+	else
+	{
+	    dmxCursorPrivPtr pCursorPriv =
+		DMX_GET_CURSOR_PRIV (wCursor (pWindow), pScreen);
+
+	    attribs->cursor = pCursorPriv->cursor;
+	}
+    }
 }
 
 /** Change the window attributes of \a pWindow. */
@@ -568,16 +673,9 @@ Bool dmxChangeWindowAttributes(WindowPtr
 {
     ScreenPtr             pScreen = pWindow->drawable.pScreen;
     DMXScreenInfo        *dmxScreen = &dmxScreens[pScreen->myNum];
-    Bool                  ret = TRUE;
     dmxWinPrivPtr         pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
     XSetWindowAttributes  attribs;
 
-    DMX_UNWRAP(ChangeWindowAttributes, dmxScreen, pScreen);
-#if 0
-    if (pScreen->ChangeWindowAttributes)
-	ret = pScreen->ChangeWindowAttributes(pWindow, mask);
-#endif
-
     /* Change window attribs on back-end server */
     dmxDoChangeWindowAttributes(pWindow, &mask, &attribs);
 
@@ -585,15 +683,14 @@ Bool dmxChangeWindowAttributes(WindowPtr
     pWinPriv->attribMask |= mask;
 
     if (mask && pWinPriv->window) {
+	XLIB_PROLOGUE (dmxScreen);
 	XChangeWindowAttributes(dmxScreen->beDisplay, pWinPriv->window,
 				mask, &attribs);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, False);
     }
 
-    DMX_WRAP(ChangeWindowAttributes, dmxChangeWindowAttributes, dmxScreen,
-	     pScreen);
-
-    return ret;
+    return TRUE;
 }
 
 /** Realize \a pWindow on the back-end server.  If the lazy window
@@ -607,10 +704,8 @@ Bool dmxRealizeWindow(WindowPtr pWindow)
     dmxWinPrivPtr  pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
 
     DMX_UNWRAP(RealizeWindow, dmxScreen, pScreen);
-#if 0
     if (pScreen->RealizeWindow)
 	ret = pScreen->RealizeWindow(pWindow);
-#endif
 
     /* Determine if the window is completely off the visible portion of
        the screen */
@@ -624,16 +719,27 @@ Bool dmxRealizeWindow(WindowPtr pWindow)
 
     if (pWinPriv->window) {
 	/* Realize window on back-end server */
-	XMapWindow(dmxScreen->beDisplay, pWinPriv->window);
-	dmxSync(dmxScreen, False);
+
+	dmxDoRedirectWindow (pWindow);
+
+	if (MapUnmapEventsEnabled (pWindow))
+	{
+	    XLIB_PROLOGUE (dmxScreen);
+	    dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
+	    XMapWindow (dmxScreen->beDisplay, pWinPriv->window);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
+
+	dmxDoUpdateWindowPixmap (pWindow);
     }
 
+    dmxSync(dmxScreen, False);
+
     /* Let the other functions know that the window is now mapped */
     pWinPriv->mapped = TRUE;
 
     DMX_WRAP(RealizeWindow, dmxRealizeWindow, dmxScreen, pScreen);
 
-    dmxUpdateWindowInfo(DMX_UPDATE_REALIZE, pWindow);
     return ret;
 }
 
@@ -646,14 +752,27 @@ Bool dmxUnrealizeWindow(WindowPtr pWindo
     dmxWinPrivPtr  pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
 
     DMX_UNWRAP(UnrealizeWindow, dmxScreen, pScreen);
-#if 0
     if (pScreen->UnrealizeWindow)
 	ret = pScreen->UnrealizeWindow(pWindow);
-#endif
 
     if (pWinPriv->window) {
 	/* Unrealize window on back-end server */
-	XUnmapWindow(dmxScreen->beDisplay, pWinPriv->window);
+
+	XLIB_PROLOGUE (dmxScreen);
+	if (MapUnmapEventsEnabled (pWindow))
+	{
+	    dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
+	    XUnmapWindow(dmxScreen->beDisplay, pWinPriv->window);
+	}
+
+	if (pWinPriv->beRedirected)
+	{
+	    XCompositeUnredirectWindow (dmxScreen->beDisplay,
+					pWinPriv->window,
+					CompositeRedirectAutomatic);
+	    pWinPriv->beRedirected = FALSE;
+	}
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, False);
     }
 
@@ -669,7 +788,6 @@ Bool dmxUnrealizeWindow(WindowPtr pWindo
 
     DMX_WRAP(UnrealizeWindow, dmxUnrealizeWindow, dmxScreen, pScreen);
 
-    dmxUpdateWindowInfo(DMX_UPDATE_UNREALIZE, pWindow);
     return ret;
 }
 
@@ -687,7 +805,10 @@ static void dmxDoRestackWindow(WindowPtr
 	m = CWStackMode;
 	c.sibling = (Window)0;
 	c.stack_mode = Below;
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+	XLIB_EPILOGUE (dmxScreen);
     } else {
 	/* Window is not at the bottom of the stack */
 	dmxWinPrivPtr  pNextSibPriv = DMX_GET_WINDOW_PRIV(pNextSib);
@@ -706,7 +827,10 @@ static void dmxDoRestackWindow(WindowPtr
 		m = CWStackMode;
 		c.sibling = (Window)0;
 		c.stack_mode = Below;
+		XLIB_PROLOGUE (dmxScreen);
+		dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 		XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+		XLIB_EPILOGUE (dmxScreen);
 		return;
 	    }
 	    pNextSibPriv = DMX_GET_WINDOW_PRIV(pNextSib);
@@ -715,7 +839,10 @@ static void dmxDoRestackWindow(WindowPtr
 	m = CWStackMode | CWSibling;
 	c.sibling = pNextSibPriv->window;
 	c.stack_mode = Above;
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+	XLIB_EPILOGUE (dmxScreen);
     }
 }
 
@@ -728,10 +855,8 @@ void dmxRestackWindow(WindowPtr pWindow,
     dmxWinPrivPtr   pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
 
     DMX_UNWRAP(RestackWindow, dmxScreen, pScreen);
-#if 0
     if (pScreen->RestackWindow)
 	pScreen->RestackWindow(pWindow, pOldNextSib);
-#endif
 
     if (pOldNextSib != pWindow->nextSib) {
 	/* Track restacking for lazy window creation optimization */
@@ -745,48 +870,6 @@ void dmxRestackWindow(WindowPtr pWindow,
     }
 
     DMX_WRAP(RestackWindow, dmxRestackWindow, dmxScreen, pScreen);
-    dmxUpdateWindowInfo(DMX_UPDATE_RESTACK, pWindow);
-}
-
-static Bool dmxWindowExposurePredicate(Display *dpy, XEvent *ev, XPointer ptr)
-{
-    return (ev->type == Expose && ev->xexpose.window == *(Window *)ptr);
-}
-
-/** Handle exposures on \a pWindow.  Since window exposures are handled
- *  in DMX, the events that are generated by the back-end server are
- *  redundant, so we eat them here. */
-void dmxWindowExposures(WindowPtr pWindow, RegionPtr prgn,
-			RegionPtr other_exposed)
-{
-    ScreenPtr      pScreen = pWindow->drawable.pScreen;
-    DMXScreenInfo *dmxScreen = &dmxScreens[pScreen->myNum];
-    dmxWinPrivPtr  pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
-    XEvent         ev;
-
-    DMX_UNWRAP(WindowExposures, dmxScreen, pScreen);
-
-    dmxSync(dmxScreen, False);
-
-    if (pWinPriv->window) {
-	while (XCheckIfEvent(dmxScreen->beDisplay, &ev,
-			     dmxWindowExposurePredicate,
-			     (XPointer)&pWinPriv->window)) {
-	    /* Handle expose events -- this should not be necessary
-	       since the base window in which the root window was
-	       created is guaranteed to be on top (override_redirect),
-	       so we should just swallow these events.  If for some
-	       reason the window is not on top, then we'd need to
-	       collect these events and send them to the client later
-	       (e.g., during the block handler as Xnest does). */
-	}
-    }
-
-#if 1
-    if (pScreen->WindowExposures)
-	pScreen->WindowExposures(pWindow, prgn, other_exposed);
-#endif
-    DMX_WRAP(WindowExposures, dmxWindowExposures, dmxScreen, pScreen);
 }
 
 /** Move \a pWindow on the back-end server.  Determine whether or not it
@@ -794,17 +877,7 @@ void dmxWindowExposures(WindowPtr pWindo
  *  lazy window creation optimization is enabled. */
 void dmxCopyWindow(WindowPtr pWindow, DDXPointRec ptOldOrg, RegionPtr prgnSrc)
 {
-    ScreenPtr       pScreen = pWindow->drawable.pScreen;
-    DMXScreenInfo  *dmxScreen = &dmxScreens[pScreen->myNum];
-    dmxWinPrivPtr   pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
-    unsigned int    m;
-    XWindowChanges  c;
-
-    DMX_UNWRAP(CopyWindow, dmxScreen, pScreen);
-#if 0
-    if (pScreen->CopyWindow)
-	pScreen->CopyWindow(pWindow, ptOldOrg, prgnSrc);
-#endif
+    dmxWinPrivPtr pWinPriv = DMX_GET_WINDOW_PRIV(pWindow);
 
     /* Determine if the window is completely off the visible portion of
        the screen */
@@ -814,20 +887,7 @@ void dmxCopyWindow(WindowPtr pWindow, DD
        been created yet, create it and map it */
     if (!pWinPriv->window && pWinPriv->mapped && !pWinPriv->offscreen) {
 	dmxCreateAndRealizeWindow(pWindow, TRUE);
-    } else if (pWinPriv->window) {
-	/* Move window on back-end server */
-	m = CWX | CWY | CWWidth | CWHeight;
-	c.x = pWindow->origin.x - wBorderWidth(pWindow);
-	c.y = pWindow->origin.y - wBorderWidth(pWindow);
-	c.width = pWindow->drawable.width;
-	c.height = pWindow->drawable.height;
-
-	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
-	dmxSync(dmxScreen, False);
     }
-
-    DMX_WRAP(CopyWindow, dmxCopyWindow, dmxScreen, pScreen);
-    dmxUpdateWindowInfo(DMX_UPDATE_COPY, pWindow);
 }
 
 /** Resize \a pWindow on the back-end server.  Determine whether or not
@@ -847,10 +907,8 @@ void dmxResizeWindow(WindowPtr pWindow,
 	pSibPriv = DMX_GET_WINDOW_PRIV(pSib);
 
     DMX_UNWRAP(ResizeWindow, dmxScreen, pScreen);
-#if 1
     if (pScreen->ResizeWindow)
 	pScreen->ResizeWindow(pWindow, x, y, w, h, pSib);
-#endif
 
     /* Determine if the window is completely off the visible portion of
        the screen */
@@ -860,7 +918,7 @@ void dmxResizeWindow(WindowPtr pWindow,
        been created yet, create it and map it */
     if (!pWinPriv->window && pWinPriv->mapped && !pWinPriv->offscreen) {
 	dmxCreateAndRealizeWindow(pWindow, TRUE);
-    } else if (pWinPriv->window) {
+    } else if (pWinPriv->window && pWindow != dmxScreen->pInputOverlayWin) {
 	/* Handle resizing on back-end server */
 	m = CWX | CWY | CWWidth | CWHeight;
 	c.x = pWindow->origin.x - wBorderWidth(pWindow);
@@ -868,12 +926,14 @@ void dmxResizeWindow(WindowPtr pWindow,
 	c.width = pWindow->drawable.width;
 	c.height = pWindow->drawable.height;
 
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, False);
     }
 
     DMX_WRAP(ResizeWindow, dmxResizeWindow, dmxScreen, pScreen);
-    dmxUpdateWindowInfo(DMX_UPDATE_RESIZE, pWindow);
 }
 
 /** Reparent \a pWindow on the back-end server. */
@@ -885,10 +945,8 @@ void dmxReparentWindow(WindowPtr pWindow
     dmxWinPrivPtr  pParentPriv = DMX_GET_WINDOW_PRIV(pWindow->parent);
 
     DMX_UNWRAP(ReparentWindow, dmxScreen, pScreen);
-#if 0
     if (pScreen->ReparentWindow)
 	pScreen->ReparentWindow(pWindow, pPriorParent);
-#endif
 
     if (pWinPriv->window) {
 	if (!pParentPriv->window) {
@@ -896,15 +954,16 @@ void dmxReparentWindow(WindowPtr pWindow
 	}
 
 	/* Handle reparenting on back-end server */
+	XLIB_PROLOGUE (dmxScreen);
 	XReparentWindow(dmxScreen->beDisplay, pWinPriv->window,
 			pParentPriv->window,
 			pWindow->origin.x - wBorderWidth(pWindow),
 			pWindow->origin.x - wBorderWidth(pWindow));
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, False);
     }
 
     DMX_WRAP(ReparentWindow, dmxReparentWindow, dmxScreen, pScreen);
-    dmxUpdateWindowInfo(DMX_UPDATE_REPARENT, pWindow);
 }
 
 /** Change border width for \a pWindow to \a width pixels. */
@@ -917,19 +976,20 @@ void dmxChangeBorderWidth(WindowPtr pWin
     XWindowChanges  c;
 
     DMX_UNWRAP(ChangeBorderWidth, dmxScreen, pScreen);
-#if 1
     if (pScreen->ChangeBorderWidth)
 	pScreen->ChangeBorderWidth(pWindow, width);
-#endif
 
     /* NOTE: Do we need to check for on/off screen here? */
 
-    if (pWinPriv->window) {
+    if (pWinPriv->window && pWindow != dmxScreen->pInputOverlayWin) {
 	/* Handle border width change on back-end server */
 	m = CWBorderWidth;
 	c.border_width = width;
 
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XConfigureWindow(dmxScreen->beDisplay, pWinPriv->window, m, &c);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, False);
     }
 
@@ -960,14 +1020,20 @@ static void dmxDoSetShape(WindowPtr pWin
 	    pBox++;
 	    pRect++;
 	}
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XShapeCombineRectangles(dmxScreen->beDisplay, pWinPriv->window,
 				ShapeBounding, 0, 0,
 				pRectFirst, nRect,
 				ShapeSet, YXBanded);
+	XLIB_EPILOGUE (dmxScreen);
 	xfree(pRectFirst);
     } else {
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XShapeCombineMask(dmxScreen->beDisplay, pWinPriv->window,
 			  ShapeBounding, 0, 0, None, ShapeSet);
+	XLIB_EPILOGUE (dmxScreen);
     }
 
     /* Next, set the clip shape */
@@ -983,19 +1049,48 @@ static void dmxDoSetShape(WindowPtr pWin
 	    pBox++;
 	    pRect++;
 	}
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XShapeCombineRectangles(dmxScreen->beDisplay, pWinPriv->window,
 				ShapeClip, 0, 0,
 				pRectFirst, nRect,
 				ShapeSet, YXBanded);
+	XLIB_EPILOGUE (dmxScreen);
 	xfree(pRectFirst);
     } else {
+	XLIB_PROLOGUE (dmxScreen);
+	dmxSetIgnore (dmxScreen, NextRequest (dmxScreen->beDisplay));
 	XShapeCombineMask(dmxScreen->beDisplay, pWinPriv->window,
 			  ShapeClip, 0, 0, None, ShapeSet);
+	XLIB_EPILOGUE (dmxScreen);
     }
 
-    if (XShapeInputSelected(dmxScreen->beDisplay, pWinPriv->window)) {
-	ErrorF("Input selected for window %x on Screen %d\n",
-	       (unsigned int)pWinPriv->window, pScreen->myNum);
+    if (wInputShape (pWindow)) {
+	pBox = REGION_RECTS(wInputShape(pWindow));
+	nRect = nBox = REGION_NUM_RECTS(wInputShape(pWindow));
+	pRectFirst = pRect = xalloc(nRect * sizeof(*pRect));
+	while (nBox--) {
+	    pRect->x      = pBox->x1;
+	    pRect->y      = pBox->y1;
+	    pRect->width  = pBox->x2 - pBox->x1;
+	    pRect->height = pBox->y2 - pBox->y1;
+	    pBox++;
+	    pRect++;
+	}
+	XLIB_PROLOGUE (dmxScreen);
+	XShapeCombineRectangles(dmxScreen->beDisplay, pWinPriv->window,
+				ShapeInput, 0, 0,
+				pRectFirst, nRect,
+				ShapeSet, YXBanded);
+	XLIB_EPILOGUE (dmxScreen);
+	xfree(pRectFirst);
+    }
+    else
+    {
+	XLIB_PROLOGUE (dmxScreen);
+	XShapeCombineMask (dmxScreen->beDisplay, pWinPriv->window,
+			   ShapeInput, 0, 0, None, ShapeSet);
+	XLIB_EPILOGUE (dmxScreen);
     }
 }
 
